/*****************************************************************************
 *  Copyright Statement:
 *  --------------------
 *  This software is protected by Copyright and the information contained
 *  herein is confidential. The software may not be copied and the information
 *  contained herein may not be used or disclosed except with the written
 *  permission of MediaTek Inc. (C) 2001
 *
 *****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   SP_META_Wrapper.h
 *
 * Project:
 * --------
 *   Maui META APP
 *
 * Description:
 * ------------
 *   SP META DLL Wrapper APIs
 *
 * Author:
 * -------
 * -------
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 * removed!
 * removed!
 * removed!
 *
 * removed!
 * removed!
 * removed!
 *
 * removed!
 * removed!
 * removed!
 *
 * removed!
 * removed!
 * removed!
 *
 * removed!
 * removed!
 * removed!
 *
 * removed!
 * removed!
 * removed!
 *
 * removed!
 * removed!
 * removed!
 *
 * removed!
 * removed!
 * removed!
 *
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
#ifndef __SP_META_WRAPPER_H__
#define __SP_META_WRAPPER_H__
#ifdef __cplusplus
extern "C" {
#endif // #ifdef __cplusplus

typedef enum
{
    SP_META_WRAPPER_SUCCESS = 0,
    SP_META_WRAPPER_TIMEOUT = 1,
    SP_META_WRAPPER_FAILED  = 2,
    SP_META_WRAPPER_EXT_MD_DOWNLOAD_FAILED = 3,
    SP_META_WRAPPER_INVALID_ARGUMENT = 4,
    SP_META_WRAPPER_INVALID_FILE = 5,
    SP_META_WRAPPER_CANCEL = 6,
    SP_META_WRAPPER_SP_META_FUNC_NOT_IMPLEMENT_YET = 7,
    SP_META_WRAPPER_SP_META_FUNC_LOAD_FAILED = 8,
    SP_META_WRAPPER_VERIFY_PASSWORD_FAILED = 9,
    SP_META_WRAPPER_LAST_ERROR
} SP_META_WRAPPER_RESULT;

SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MapToSPMetaWrapperResult (int spMetaResult);
const char* __stdcall SP_META_Wrapper_GetErrorString(SP_META_WRAPPER_RESULT ErrCode);
const char* __stdcall SP_META_Wrapper_GetLastExecuteSPMetaApiName();
const char* __stdcall SP_META_Wrapper_GetLastExecuteSPMetaApiName_r(const int meta_handle);

SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetSPMetaHandle(int handle, int* spMetaHandle);
/**
 * Trace on /off API for SP META Wrapper
 */
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_TraceOn(void);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_TraceClear(void);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_TraceOff(void);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_TraceOn_With_FilePath(const char* filename);
/**
 * init Wrapper API for SP META DLL
 */
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_Init(void);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_InitSingle(int handle);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_Deinit(int handle);
/**
 * Trace on /off Wrapper API for SP META DLL
 */
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_DebugOn(void);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_DebugOn_ex(const int meta_handle);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_DebugOff(void);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_DebugClear(void);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_DebugOnThePath(const char* path);
/**
 * non-reentrant version of SP_META_Wrapper_ConnectTargetByUart_r
 */
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ConnectTargetByUart(unsigned int ms_timeout, int com_port);
/**
 * \brief connect AP with 921600 baud rate
 * \param metaHandle meta handle
 * \param connectionSetting connection setting to the UART interface
 */
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ConnectTargetByUart_r(const int meta_handle, unsigned int ms_timeout, int com_port);
typedef enum _SP_META_WRAPPER_UART_BAUDRATE_E
{
    SP_META_WRAPPER_BAUDRATE_END = -1,
    SP_META_WRAPPER_BAUDRATE_57600 = 0,
    SP_META_WRAPPER_BAUDRATE_115200 = 1,
    SP_META_WRAPPER_BAUDRATE_230400 = 2,
    SP_META_WRAPPER_BAUDRATE_460800 = 3,
    SP_META_WRAPPER_BAUDRATE_921600 = 4,
    SP_META_WRAPPER_BAUDRATE_1500000 = 5,
    SP_META_WRAPPER_BAUDRATE_NUM = SP_META_WRAPPER_BAUDRATE_1500000 + 1
} SP_META_WRAPPER_UART_BAUDRATE_E;
typedef struct _SP_META_WRAPPER_CONN_UART_SETTING_T
{
    int comPort;
    SP_META_WRAPPER_UART_BAUDRATE_E baudrateSetting[SP_META_WRAPPER_BAUDRATE_NUM];
} SP_META_WRAPPER_CONN_UART_SETTING_T;
/**
 * non-reentrant version of SP_META_Wrapper_ConnectTargetByUartEx_r
 */
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ConnectTargetByUartEx(unsigned int msTimeout, const SP_META_WRAPPER_CONN_UART_SETTING_T* connectionSetting, SP_META_WRAPPER_UART_BAUDRATE_E* currentBaudRate);
/**
 * \brief connect AP with configurable connection setting
 * \param metaHandle meta handle
 * \param connectionSetting connection setting to the UART interface
 */
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ConnectTargetByUartEx_r(const int metaHandle, unsigned int msTimeout, const SP_META_WRAPPER_CONN_UART_SETTING_T* connectionSetting, SP_META_WRAPPER_UART_BAUDRATE_E* currentBaudRate);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ConnectTargetByUsb(unsigned int ms_timeout, int com_port);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ConnectTargetByUsb_r(const int meta_handle, unsigned int ms_timeout, int com_port);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_DisconnectInMetaMode(void);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_DisconnectInMetaMode_r(const int meta_handle);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_DisconnectWithTarget(void);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_DisconnectWithTarget_r(const int meta_handle);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_TriggerBackupByUart(unsigned int ms_timeout, int com_port, bool value = 0);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_TriggerBackupByUart_r(const int meta_handle, unsigned int ms_timeout, int com_port, bool value = 0);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_TriggerBackupByUsb(unsigned int ms_timeout, int com_port, bool value = 0);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_TriggerBackupByUsb_r(const int meta_handle, unsigned int ms_timeout, int com_port, bool value = 0);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ShutdownTargetByUart(const int meta_handle, unsigned int ms_timeout, int com_port);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ShutdownTargetByUart_r(const int meta_handle, unsigned int ms_timeout, int com_port);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ShutdownTargetByUsb(const int meta_handle, unsigned int ms_timeout, int com_port);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ShutdownTargetByUsb_r(const int meta_handle, unsigned int ms_timeout, int com_port);
typedef struct
{
    char	BB_CHIP[64];	// BaseBand chip version
    char	ECO_VER[4];		// ECO version
    char	SW_TIME[64];
    char	DSP_FW[64];		// DSP firmware version
    char	DSP_PATCH[64];	// DSP patch version
    char	SW_VER[64];		// S/W version
    char	HW_VER[64];		// H/W board version
    char	MELODY_VER[64];	// Melody version
    char	BUILD_DISP_ID[64];  //build version
} SP_META_WRAPPER_VERINFO;
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetTargetVerInfo(SP_META_WRAPPER_VERINFO * verinfo);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetTargetVerInfo_r(const int meta_handle, SP_META_WRAPPER_VERINFO * verinfo);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_QueryEncryptedSupport(unsigned int ms_timeout, unsigned char* support);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_QueryEncryptedSupport_r(const int meta_handle, unsigned int ms_timeout, unsigned char* support);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_VerifyEncryptedPwd(const unsigned char* pwd, unsigned int ms_timeout, const int  length, unsigned char* result);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_VerifyEncryptedPwd_r(const int meta_handle, unsigned int ms_timeout, const unsigned char* pwd, const int  length, unsigned char* result);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetModemInfo(unsigned int ms_timeout, unsigned int* number_of_md, unsigned int* active_md_idx);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetModemInfo_r(const int meta_handle, unsigned int ms_timeout, unsigned int* number_of_md, unsigned int* active_md_idx);
typedef struct
{
    unsigned int md_service; /*!< logging_protocol type: 1: TST;2: DHL*/
    unsigned int ch_type; /*!< channel type: 0/1: Native Channel; 2: Tunneling without checksum; 3: Tunneling with checksum */
    unsigned char reserved;
} SP_MODEM_CAPABILITY;
typedef struct
{
    SP_MODEM_CAPABILITY modem_cap[8];
} SP_MODEM_CAPABILITY_LIST_CNF;
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_QueryModemCapability(unsigned int ms_timeout, SP_MODEM_CAPABILITY_LIST_CNF* md_cap_list);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_QueryModemCapability_r(const int meta_handle, unsigned int ms_timeout, SP_MODEM_CAPABILITY_LIST_CNF* md_cap_list);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_SetModemType(unsigned int ms_timeout, unsigned int active_md_idx, unsigned int active_md_type);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_SetModemType_r(const int meta_handle, unsigned int ms_timeout, unsigned int active_md_idx, unsigned int active_md_type);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetCurrentModemType(unsigned int ms_timeout, unsigned int current_md_idx, unsigned int* current_md_type);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetCurrentModemType_r(const int meta_handle, unsigned int ms_timeout, unsigned int current_md_idx, unsigned int* current_md_type);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_QueryMdImgType(unsigned int ms_timeout, unsigned int current_md_idx, unsigned int* current_mdimg_type_idx);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_QueryMdImgType_r(const int meta_handle, unsigned int ms_timeout, unsigned int current_md_idx, unsigned int* current_mdimg_type_idx);
//Modify naming
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MODEM_Set_ModemType(unsigned int ms_timeout, unsigned int active_md_idx, unsigned int active_md_type);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MODEM_Set_ModemType_r(const int meta_handle, unsigned int ms_timeout, unsigned int active_md_idx, unsigned int active_md_type);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MODEM_Get_CurrentModemType(unsigned int ms_timeout, unsigned int current_md_idx, unsigned int* current_md_type);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MODEM_Get_CurrentModemType_r(const int meta_handle, unsigned int ms_timeout, unsigned int current_md_idx, unsigned int* current_md_type);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MODEM_Query_MDIMGType(unsigned int ms_timeout, unsigned int current_md_idx, unsigned int* current_mdimg_type_idx);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MODEM_Query_MDIMGType_r(const int meta_handle, unsigned int ms_timeout, unsigned int current_md_idx, unsigned int* current_mdimg_type_idx);
typedef struct
{
    unsigned char reserved;
} SP_META_WRAPPER_MODEM_QUERY_DOWNLOAD_STATUS_REQ;

typedef struct
{
    unsigned int percentage;
    unsigned int status_code;
} SP_META_WRAPPER_MODEM_QUERY_DOWNLOAD_STATUS_CNF;
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MODEM_Query_Download_Status(unsigned int ms_timeout, SP_META_WRAPPER_MODEM_QUERY_DOWNLOAD_STATUS_REQ* pReq, SP_META_WRAPPER_MODEM_QUERY_DOWNLOAD_STATUS_CNF* pCnf);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MODEM_Query_Download_Status_r(const int meta_handle, unsigned int ms_timeout, SP_META_WRAPPER_MODEM_QUERY_DOWNLOAD_STATUS_REQ* pReq, SP_META_WRAPPER_MODEM_QUERY_DOWNLOAD_STATUS_CNF* pCnf);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MODEM_Query_ExternalModemDownloadSupport(unsigned int ms_timeout);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MODEM_Query_ExternalModemDownloadSupport_r(const int meta_handle, unsigned int ms_timeout);
/********************************************
 *      NVRAM access SP META DLL WRAPPER    *
 ********************************************/

// Read from NVRAM
typedef struct
{
    const char*          LID;       // The name of logical data item ID
    unsigned short      RID;        // Record ID (the first record is 1)
} SP_FT_NVRAM_READ_REQ;

typedef struct
{
    unsigned short      LID;        // Logical data item ID of a EF
    unsigned short      RID;        // Record ID (the first record is 1)
    unsigned char       status;     // 0: read ok; others: read failed.

    unsigned int        len;        // [IN] Length of Buffer, [OUT] Length of read data
    // The "len" field indicates the size of "buf" you
    // allocated. When the data is read back, "len" will
    // be replaced with the actual size of the data.

    unsigned char*       buf;       // Buffer that will contains the content of record
    unsigned char       read_status;
} SP_FT_NVRAM_READ_CNF;

//Write to NVRAM
typedef struct
{
    const char*          LID;       // The name of logical data item ID
    unsigned short      RID;        // Record ID (the first record is 1)
    unsigned int        len;        // Length of write data
    unsigned char*       buf;       // Buffer that contains the content of record
} SP_FT_NVRAM_WRITE_REQ;

typedef struct
{
    unsigned short      LID;        // Logical data item ID of a EF
    unsigned short      RID;        // Record ID (the first record is 1)
    unsigned char       write_status;
    unsigned char       status;     // 0: write ok; others: write failed.
} SP_FT_NVRAM_WRITE_CNF;

// NVRAM database initial function
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_Init(const char* PathName, unsigned long* p_nvram_CatcherTranAddr);
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_Init_r(const int meta_handle, const char* PathName, unsigned long* p_nvram_CatcherTranAddr);

// NVRAM read/write operations
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_Read(unsigned int ms_timeout, const SP_FT_NVRAM_READ_REQ* req, SP_FT_NVRAM_READ_CNF* cnf);
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_Read_r(const int meta_handle, unsigned int ms_timeout, const SP_FT_NVRAM_READ_REQ* req, SP_FT_NVRAM_READ_CNF* cnf);
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_Write(unsigned int ms_timeout, const SP_FT_NVRAM_WRITE_REQ* req);
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_Write_r(const int meta_handle, unsigned int ms_timeout, const SP_FT_NVRAM_WRITE_REQ* req);

// NVRAM query operations
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_GetRecLen(const char* LID, int* len);
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_SetRecFieldValue(const char* LID, const char* field, char* buf, const int buf_len, void* value, const int value_len);
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_GetRecFieldValue(const char* LID, const char* field, const char* buf, const int buf_len, void* value, const int value_len);
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_QueryIsLIDExist(const char* LID);

// NVRAM export/import
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_Export(unsigned int ms_timeout, const char *file1, const char *file2);
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_Export_r(const int meta_handle, unsigned int ms_timeout, const char *file1, const char *file2);
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_Import(unsigned int ms_timeout, const char *file1, const char *file2);
SP_META_WRAPPER_RESULT  __stdcall SP_META_Wrapper_NVRAM_Import_r(const int meta_handle, unsigned int ms_timeout, const char *file1, const char *file2);

/********************************************
 *      Platform related flow API
 ********************************************/
#define SP_META_WRAPPER_STOP_CHECK_EXTERNAL_MODEM_DOWNLOAD_STATUS 0x5566
typedef void (__stdcall* SP_META_Wrapper_ExternalModemDownloadStatusCallback_T)(unsigned int progress, unsigned int statusCode, void* usrData);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_Flow_CheckExternalModemDownloadStatus(unsigned int ms_timeout, const int* pStop, int* pDownloadStatus, SP_META_Wrapper_ExternalModemDownloadStatusCallback_T reportCallback, void* usrData);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_Flow_CheckExternalModemDownloadStatus_r(const int meta_handle, unsigned int ms_timeout, const int* pStop, int* pDownloadProgress, int* pDownloadStatus, SP_META_Wrapper_ExternalModemDownloadStatusCallback_T reportCallback, void* usrData);

SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_QueryIfFunctionSupportedByTarget(unsigned int ms_timeout, const char* func);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_QueryIfFunctionSupportedByTarget_r(const int meta_handle, unsigned int ms_timeout, const char* func);
/* backup nvram data (misnamed)*/
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_SetCleanBootFlag(unsigned int ms_timeout);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_SetCleanBootFlag_r(const int meta_handle, unsigned int ms_timeout);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ADC_SetCarTuneVal_r(const int meta_handle, unsigned int ms_timeout, int val);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ADC_GetCarTuneVal_r(const int meta_handle, unsigned int ms_timeout, int *val);

/********************************************
 *      Load Nvram file Platform API
 ********************************************/
#define DEFAULT_TARGET_FILEPATH "//system//etc//mddb"
#define PATTERN_FILENAME "MDDB.META_"
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_QueryModemDatabasePath(const int meta_handle, unsigned int ms_timeout, char *file_path);
typedef struct
{
	char          target_foldername[256];      
	const char*   pattern_filename;
	const char*   MD_type;
	char          database_filepath[256];
} SP_GET_NVRAM_DB_REQ;
typedef struct
{
	char          database_filename[256];
} SP_GET_NVRAM_DB_CNF;
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_TravelTargetSideFile(const int meta_handle, unsigned int ms_timeout, char *pTargetfoldername, char *pattern_filename, unsigned int *file_count);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetTargetSideFileInfo(const int meta_handle, unsigned int ms_timeout, unsigned int file_idx, unsigned int *file_size, char *file_name);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_ReceiveTargetSideFile(const int meta_handle, unsigned int ms_timeout, const char *pSourceFileName, const char *pDestFileName);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_IsSupportedLoadSPNvDb(const int meta_handle, unsigned int ms_timeout);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_LoadSPNvDatabase(const int meta_handle, unsigned int ms_timeout, SP_GET_NVRAM_DB_REQ *p_req, SP_GET_NVRAM_DB_CNF *p_cnf);
/********************************************
 *      Reboot Platform to Normal mode API
 ********************************************/
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_RebootToNormalMode_r(const int meta_handle);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_RebootModemAndChangeMode_r(const int meta_handle, unsigned int ms_timeout, unsigned char md_idx, unsigned char meta_mode);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_RebootModemAndChangeModebyUSB_r(const int meta_handle, unsigned int ms_timeout, unsigned char md_idx, unsigned char meta_mode, int com_port);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_RebootModemAndChangeModebyUart_r(const int meta_handle, unsigned int ms_timeout, unsigned char md_idx, unsigned char meta_mode, int com_port);

/********************************************
 *      Clear Meta_boot flag to Normal mode API
 ********************************************/
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_CleanMetaBootFlag_r(const int meta_handle, unsigned int ms_timeout, const char* APDB_pahtName);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_CleanMetaBootFlagByUsb_r(const int meta_handle, unsigned int ms_timeout, int com_port, const char* APDB_pahtName);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_CleanMetaBootFlagByUart_r(const int meta_handle, unsigned int ms_timeout, int com_port, const char* APDB_pahtName);

/********************************************
 *      Control MeteMode MDlogger API
 ********************************************/
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_IsSupportedControlMdlogger_r(const int meta_handle, unsigned int ms_timeout);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MdloggerUsbLoggingControl_r(const int meta_handle, unsigned int ms_timeout, bool enableLogging);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_MdloggerSdcardLoggingControl_r(const int meta_handle, unsigned int ms_timeout, bool enableLogging);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_IsSupportedMdloggerStatus_r(const int meta_handle, unsigned int ms_timeout);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetMdloggerStatus_r(const int meta_handle, unsigned int ms_timeout, unsigned int *mdStatus);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_LoadSDcardMdLog(const int meta_handle, unsigned int ms_timeout, char *target_foldername, char *filename, unsigned int LogByteUpperBound);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetMdLogPathWhenNormalStatus(const int meta_handle, unsigned int ms_timeout, char *mdLogPath);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetMdLogPathWhenExceptionStatus(const int meta_handle, unsigned int ms_timeout, char *mdLogPath);

/********************************************
 *      Control MeteMode APlogger API
 ********************************************/
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_IsSupportedControlApLogger_r(const int meta_handle, unsigned int ms_timeout);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_APlogControl_r(const int meta_handle, unsigned int ms_timeout, unsigned int storeLogMode, unsigned int loggingAction);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_GetAPLogPath_r(const int meta_handle, unsigned int ms_timeout, char *ApLogPath);
SP_META_WRAPPER_RESULT __stdcall SP_META_Wrapper_LoadSDcardApLog(const int meta_handle, unsigned int ms_timeout, char *target_foldername, char *log_filepath);

#ifdef __cplusplus
}
#endif // #ifdef __cplusplus
#endif // #ifndef __SP_META_WRAPPER_H__
