#ifndef __SP_PROXY_CONN_PARA__
#define __SP_PROXY_CONN_PARA__
#include "sp_brom.h"
#include "sp_conn_para.h"

typedef enum
{
    SpProxyClientType_None = -1,
    SpProxyClientType_Master = 0,
    SpProxyClientType_Slave = 1,
    SpProxyClientType_TypeCount
} SpProxyClientTypeEnum;

typedef struct _SpProxyConnMdInfo
{
    unsigned int m_iSpNumberOfMd; //how many modems in the target
    unsigned int m_iSpActiveMd;   //the index of modem which is actived so far
    unsigned int m_iSpAllMdChannelIndex[MAX_MD_NUM]; //Modem index of each modem
    unsigned int m_iSpNumberOfMdType[MAX_MD_NUM]; //The number of images of each modem
    unsigned int m_iSpActiveMdType[MAX_MD_NUM]; //The active image of each modem
    unsigned int m_iSpAllMdSwImg[MAX_MD_NUM][MAX_MD_SW_NUM]; //Images of each modem queried from SP meta dll
    unsigned int m_iSpNumberOfMdSwImg; //how many modem images in the target
    SP_MODEM_CAPABILITY_LIST_CNF m_SpMdCapList; //
    bool m_bSpMultiMdCapabilitySupport;
    bool m_bSpMultiMdSupport;
    bool m_bSpMultiMdTypeSupport;
    bool m_bSpEncryptSupport;
    bool m_bExternalModemDownloadSupport;
    bool m_bSupportBackup;
    bool m_bSupportLoadNVramDB;
    bool m_bSupportControlMDLogger;
} SpProxyConnMdInfo;

typedef struct
{
    int proxyClientType;
    SpProxyConnMdInfo mdInfo;
    SP_Conn_Input spConnInput;
} SpProxyConnInput;

#endif // #ifndef __SP_PROXY_CONN_PARA__